package biocreative.webservice;

import java.io.IOException;

import javax.servlet.ServletException;

import org.apache.xmlrpc.webserver.XmlRpcServlet;
import org.apache.xmlrpc.webserver.ServletWebServer;

/**
 * Standalone AnnotationServlet implementaion using the Apache XML-RPC
 * ServletWebServer class.
 * 
 * This is the default server to use. To start a new server process, use
 * <code>java biocreative.webservice.AnnotationServlet</code> and the server
 * runs 'forever'.
 */
public class AnnotationServlet {

    public static void main(String[] args) throws ServletException {

        /* Initialize the AnnotationServer.properties */
        ServerProperties serverProps = null;
        try {
            serverProps = new ServerProperties();
            /*
             * alternatively, you can specify another location than the
             * default properties using this line:
             * ServerProperties serverProps =
             *     new ServerProperties("my/path/to/server.properties");
             */
        } catch (Exception ex) {
            ex.printStackTrace(System.err);
            System.exit(1);
        }

        /* Initialize the Servlet */
        // XmlRpcServlet servlet = (XmlRpcServlet) new MyXmlRpcServlet();
        /* Initialize the Servlet, Frederic Ehrlers way */
        XmlRpcServlet servlet = new XmlRpcServlet();
        ServletWebServer webServer = null;
        webServer = new ServletWebServer(
            servlet, serverProps.getPort(), serverProps.getServerIP()
        );
        
        /* Optional settings to enhance security */
        /*
        server.setParanoid(true);
        if (serverProps.getClientIPs() != null) {
            for (Object ip: serverProps.getClientIPs()) {
                server.acceptClient((String) ip);
            }
        }
        */

        /* Initialize the property handler file */
        /*
         * The Servlet uses the default property file in
         * org/apache/xmlrpc/webserver/XmlRpcServlet.properties which can be
         * found in the xmlrpc-server-[version].jar file. By default, the
         * handler is mapped to the name 'annotator' and the class
         * biocreative.webservice.AnnotationHandler
         */

        /* Start the web service */
        try {
            webServer.start();
        } catch (IOException ex) {
            webServer.shutdown();
            ex.printStackTrace(System.err);
            System.exit(1);
        }
    }
}