package biocreative.webservice;

import java.util.Map;

import org.apache.xmlrpc.XmlRpcException;

/**RPC class for the Annotation Server for MEDLINE annotations. */
public class Medline {
    
    /**This is the method your Annotation Server must implement.
     *
     * This method is called by the BCMS. Your text mining pipeline then has
     * to be initialized with the received text Object[]. Finally, this
     * method should return a Result HashMap with the classifications for the
     * text as produced by your pipeline.
     */
    public Map getAnnotation(Integer pmid) throws XmlRpcException {
        System.out.println("PMID=" + pmid);
        Result result = new Result();
        return (Map) result.sampleResult();
    }
}